package com.starcharge.wios.Import.impl;

import com.starcharge.wios.Import.Import;
import com.starcharge.wios.convert.DeliveryConvert;
import com.starcharge.wios.dao.entity.Order;
import com.starcharge.wios.dao.entity.WallboxApply;
import com.starcharge.wios.dao.mappers.OrderMapper;
import com.starcharge.wios.dao.mappers.WallboxApplyMapper;
import com.starcharge.wios.dto.WarehouseDTO2;
import com.starcharge.wios.dto.WarehouseQuery2;
import com.starcharge.wios.enums2.ProductType;
import com.starcharge.wios.service.WarehouseService;
import com.starcharge.wios.validation.CreateEntityGroup;
import com.starcharge.wios.vo.DeliveryAddVo;
import com.starcharge.wios.vo.WallboxApplyInstallListVO;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.validation.ConstraintViolation;
import javax.validation.Validator;
import java.util.Arrays;
import java.util.List;
import java.util.Set;

/**
 * @projectName:xr-wios
 * @packageName:com.starcharge.wios.Import.impl
 * @Description:TODO
 * @Author:luyincheng
 * @CreateDate: 2023/10/1317:01
 */
@Service
public class DeliveryImport implements Import {

    public interface BatchCreateEntityGroup {
    }

    @Autowired
    private Validator validator;
    @Autowired
    private OrderMapper orderMapper;
    @Autowired
    private WallboxApplyMapper wallboxApplyMapper;
    @Override
    public List<?> handle(List<Object> list) {
//        List<String> headList = (List<String>)list.get(0);

        for(int i=list.size()-1;i>2;i--){
            list.remove(i);
        }

        for(int i=1;i<list.size();i++){
            List<String> rowdata = (List<String>)list.get(i);
            DeliveryAddVo deliveryAddVo=new DeliveryAddVo();
            deliveryAddVo.setInstallOrder(rowdata.get(0));
            deliveryAddVo.setMaterialSn(rowdata.get(1));
            deliveryAddVo.setLogisticOrder(rowdata.get(2));
//            deliveryAddVo.setMaterialCategory(rowdata.get(2));
//            deliveryAddVo.setMaterialCode(rowdata.get(3));
//            deliveryAddVo.setMaterialName(rowdata.get(4));
//            deliveryAddVo.setMaterialCompany(rowdata.get(5));
//            deliveryAddVo.setLogisticOrder(rowdata.get(6));
//            deliveryAddVo.setTeam(rowdata.get(7));


            Set<ConstraintViolation<DeliveryAddVo>> sets =  validator.validate(deliveryAddVo, DeliveryImport.BatchCreateEntityGroup.class);
            if(!sets.isEmpty()){
                rowdata.add(sets.stream().map(ConstraintViolation::getMessage).reduce("error:",(s1,s2)->s1+";"+s2));
                continue;
            }
            WallboxApply wallboxApplyquery=new WallboxApply();
            wallboxApplyquery.setOrderId(deliveryAddVo.getInstallOrder());
            wallboxApplyquery.setCheckStatus(2l);
            List<WallboxApplyInstallListVO> wallboxs= this.wallboxApplyMapper.selectWallboxApplyListFromOrder(wallboxApplyquery);
            if(CollectionUtils.isEmpty(wallboxs)){
                rowdata.add("error:未找到已审批墙盒申请单!");
            }else if(wallboxs.stream().noneMatch(w-> StringUtils.isEmpty(w.getTrackingStatus())||"0".equals(w.getTrackingStatus()))){
                rowdata.add("error:已审批墙盒申请单必须为未发货状态!");
            }
//            String error = "error:";
//            if(ProductType.品牌墙盒.name().equals(deliveryAddVo.getMaterialCategory())||
//                    ProductType.三方墙盒.name().equals(deliveryAddVo.getMaterialCategory())){
//                if(ProductType.品牌墙盒.name().equals(deliveryAddVo.getMaterialCategory())){
//                    //判断订单中是否品牌墙盒
//                    Order order=this.orderMapper.selectById(deliveryAddVo.getInstallOrder());
//                    if(order==null||!"CAMS".equals(order)){
//                        error+="订单必须是CAMS品牌墙盒订单;";
//                    }
//                }
//            }else {
//                error+="物料类型必须是："+ ProductType.品牌墙盒.name()+"/"+ProductType.三方墙盒.name()+";";
//
//            }
//
//            if(error.length()>0){
//                rowdata.add(error);
//                continue;
//            }
        }
        return list;
    }
}
